////////////////////////////////////////////////////////////////////////////////////
// margu-NotebookInfo2 Gadget
////////////////////////////////////////////////////////////////////////////////////

System.Gadget.settingsUI="/settings.html";
System.Gadget.onSettingsClosed = SettingsClosed;

var tv = System.Gadget.version;
var gname = System.Gadget.name;
var Homepage = "http://gadget.margu.eu";

var DisplayInGHz;
var DisplayDualCore;
var AutoUpdate;
var status;
var network = System.Network;
var wireless = network.Wireless;
var machine = System.Machine;
var powerstatus = machine.PowerStatus;
var cpus = machine.CPUs;
var WMI = null;
var stat = false;
var prcolor = false;
var oTime = System.Time;
var lastT = 0;
var aktT;
var altbcal = null;
var timeout = null;

var detectSetting = null;
var calculatedRT = -1; // calculated remaining time
var validTimePerPCT = -1;
var lastpct = -1;

var doingCalc = false;

var PCT = new Array(-1, -1, -1); // stores the last 3 percentage remaining values (pct values may not be continuous if the computer has been put into sleep mode and consumed battery power)
var timePCT = new Array(null, null, null); // stores the corresponding times at which pct values have been reached

wmtt = null;
var x, y;
document.onmousemove = updateWMTT;

function Init()
{
	LoadSettings()
    onTimer();
    setInterval("onTimer()",1000);
	aupdate();
}

function onTimer()
{
	Refresh();
}

function LoadSettings()
{
	if(System.Gadget.Settings.read("dispdualcore")!="")
	{
		DisplayDualCore=System.Gadget.Settings.read("dispdualcore");
	}
	else
	{
		DisplayDualCore=0;
		System.Gadget.Settings.write("dispdualcore",DisplayDualCore);
	}

	if(System.Gadget.Settings.read("dispinghz")!="")
	{
		DisplayInGHz=System.Gadget.Settings.read("dispinghz");
	}
	else
	{
		DisplayInGHz=0;
		System.Gadget.Settings.write("dispinghz",DisplayInGHz);
	}

	if(System.Gadget.Settings.read("autoupdate")!="")
	{
		AutoUpdate=System.Gadget.Settings.read("autoupdate");
	}
	else
	{
		AutoUpdate=0;
		System.Gadget.Settings.write("autoupdate",AutoUpdate);
	}

	if(System.Gadget.Settings.read("homepage")!="")
	{
		Homepage=System.Gadget.Settings.read("homepage");
	}
	else
	{
		System.Gadget.Settings.write("homepage",Homepage);
	}

	if(System.Gadget.Settings.read("altbcal")!="")
	{
		altbcal=System.Gadget.Settings.read("altbcal");
	}
	else
	{
		altbcal=0;
		System.Gadget.Settings.write("altbcal",altbcal);
	}
}

function aupdate()
{
	if (AutoUpdate)
	{
		var check = checkupdate(AutoUpdate);
		if (check)
		{
			var confirmtext = "A new version of " + gname + " is available.\n";
			confirmtext += "Your Version: " + tv + "\n";
			confirmtext += "New Version : " + nbiaktver + "\n\n";
			confirmtext += "Download now?"
			var download = confirm(confirmtext);
			if (download)
			{
				System.Shell.execute(nbipath);

			}
		}
	}
}

function checkupdate(check)
{
	if (check)
	{
		if (tv < nbiaktver)
		{
			return "yes";
		}
		else
		{
			return;
		}
	}
}

function Refresh()
{
	WMI = GetObject("winmgmts:\\\\.\\root\\CIMV2");
	CPUInfo();
	networkInfo();
	checkbatt();
}

function startPCT()
{
    return (PCT[2] != -1 ? PCT[2] : PCT[1]);
}

function startPCTtime()
{
    return (timePCT[2] != null ? timePCT[2] : timePCT[1]);
}

function reinitCounters()
{
    PCT = new Array(-1, -1, -1);
    timePCT = new Array(null, null, null);
}

//calculates Remaining Time
function calcRT()
{
    doingCalc = true;
    var currentPCT = powerstatus.batteryPercentRemaining;

    if(PCT[0] == -1)
        PCT[0] = currentPCT;

    if(currentPCT > PCT[0]) // battery has been charged while computer was sleeping

    {
        reinitCounters();
    }
    else if(currentPCT < PCT[0]) // pct remaining has changed since the last time this function was executed
    {
        timePCT[2] = timePCT[1];
        timePCT[1] = timePCT[0];
        timePCT[0] = new Date();
        if(timePCT[1] != null)
        {
            PCT[2] = PCT[1];
            PCT[1] = PCT[0];
        }
        PCT[0] = currentPCT;

        if(PCT[0] < startPCT())
        {
            var timePerPCT= (timePCT[0] - startPCTtime())/1000 /(startPCT() - PCT[0]);
            var referenceTimePerPCT = timePerPCT;

            if(timePCT[2] != null)
                referenceTimePerPCT = (timePCT[1] - timePCT[2])/1000;
            else if(validTimePerPCT != -1)
                referenceTimePerPCT = validTimePerPCT;

            if((timePerPCT > referenceTimePerPCT * 2) && timePCT[2] != null)
            {
                //reinit counters because of bad calculation (due to computer having been put on sleep since the beginning of the calculation)
                reinitCounters();
            }
            else
            {
                validTimePerPCT = timePerPCT;
                System.Gadget.Settings.write("timeperpct", validTimePerPCT);
            }
        }
    }

    if(validTimePerPCT != -1)
    {
        calculatedRT = Math.floor(validTimePerPCT/60 * currentPCT);
    }

    if(!powerstatus.isPowerLineConnected)
    {
		setTimeout("calcRT()", 5000);
	}
	else
    {
        reinitCounters();
        doingCalc = false;
    }
}

function getTime()
{
	var oSelectedTimeZone = oTime.currentTimeZone;
	var sTimeInfo = oTime.getLocalTime(oSelectedTimeZone);
	if (sTimeInfo != "")
	{
		aktT = "";
		var dDateInfo = new Date(Date.parse(sTimeInfo));
		tHours = dDateInfo.getHours();
		tMinutes = dDateInfo.getMinutes();
		tlMinutes = tMinutes;
		if (tlMinutes < 10) tlMinutes = "0" + tlMinutes;
		if (tMinutes < 10) tMinutes = "0" + tMinutes;
		tSeconds = dDateInfo.getSeconds();
		tlSeconds = tSeconds + 5;
		if (tlSeconds < 10) tlSeconds = "0" + tlSeconds;
		if (tSeconds < 10) tSeconds = "0" + tSeconds;
		aktT = aktT + tHours + tMinutes + tSeconds;
	}
}

function checkbatt()
{
	clearTimeout(timeout);
	timeout = setTimeout("checkbatt()", 10000);

	var pctRemaining = powerstatus.batteryPercentRemaining;

	lastpct = pctRemaining;
	var lastpcttext;
	var lastpcttext2="";

	if (pctRemaining == 255) // no battery
	{
		lastpcttext2= BattText[5];
		lastpcttext = BattText[10];
		lastpct = "--";
		document.getElementById('battimage').src = "/img/BatteryMissing.png";
	}
	else if (!powerstatus.isPowerLineConnected) //running on battery
	{
		var remaining = 0;

        if(!altbcal && !detectSetting)
        {
            remaining = getRemainingTime();
        }
        else if(altbcal) //alternative calculation explicitly set
        {
            if(!doingCalc)
            {
                reinitCounters();
                calcRT();
            }
            remaining = calculatedRT;
        }
        else //not yet sure which calculation method to use
        {
            remaining = getRemainingTime();
            if((remaining == 0 && pctRemaining > 0) || remaining == -1 || remaining == 71582788 || remaining == null)
            {
                if(!doingCalc)
                {
                    reinitCounters();
                    calcRT();
                }
                remaining = calculatedRT;

                if(startPCTtime()!=null && (timePCT[0] - startPCTtime()> 60000))
                {
                    altbcal = true;
                    detectSetting = false;
                    System.Gadget.Settings.write("detectSetting", false);
                    System.Gadget.Settings.write("altbcal", true);
                }
            }
            else //valid remaining time retrieved
            {
                detectSetting = false;
                System.Gadget.Settings.write("detectSetting", false);
            }
        }

		var hRemaining = Math.floor(remaining / 60);
		var mRemaining = remaining % 60;

		if (remaining != 71582788 && remaining != -1)
		{
			if (lastpct >= 40)
			{
				lastpcttext = BattText[6];
			}
			lastpcttext2 = hRemaining + ":" + padnumber(mRemaining) + "h " + BattText[2];
		}
		else
		{
			lastpcttext = BattText[6];
			lastpcttext2 = BattText[12];
		}

		if (lastpct >= 98)
		{
			document.getElementById('battimage').src = "/img/Battery100.png";
			document.getElementById('batt').style.color = "white";
		}
		else if (lastpct >= 90)
		{
			document.getElementById('battimage').src = "/img/Battery90.png";
			document.getElementById('batt').style.color = "white";
		}
		else if (lastpct >= 80)
		{
			document.getElementById('battimage').src = "/img/Battery80.png";
			document.getElementById('batt').style.color = "white";
		}
		else if (lastpct >= 70)
		{
			document.getElementById('battimage').src = "/img/Battery70.png";
			document.getElementById('batt').style.color = "white";
		}
		else if (lastpct >= 60)
		{
			document.getElementById('battimage').src = "/img/Battery60.png";
			document.getElementById('batt').style.color = "white";
		}
		else if (lastpct >= 50)
		{
			document.getElementById('battimage').src = "/img/Battery50.png";
			document.getElementById('batt').style.color = "white";
		}
		else if (lastpct >= 40)
		{
			document.getElementById('battimage').src = "/img/Battery40.png";
			document.getElementById('batt').style.color = "white";
		}
		else if (lastpct >= 30)
		{
			document.getElementById('battimage').src = "/img/Battery30.png";
			document.getElementById('batt').style.color = "yellow";
			lastpcttext = BattText[3];
		}
		else if (lastpct >= 20)
		{
			document.getElementById('battimage').src = "/img/Battery20.png";
			document.getElementById('batt').style.color = "red";
			lastpcttext = BattText[3];
		}
		else if (lastpct >= 10)
		{
			document.getElementById('battimage').src = "/img/Battery10.png";
			document.getElementById('batt').style.color = "red";
			blinker();
			lastpcttext = BattText[4];
		}
		else if (lastpct >= 1)
		{
			document.getElementById('battimage').src = "/img/Battery0ani.gif";
			document.getElementById('batt').style.color = "red";
			blinker();
			lastpcttext = BattText[4];
		}
		else
		{
			document.getElementById('battimage').src = "/img/BatteryPlugged.png";
			document.getElementById('batt').style.color = "green";
		}
	}
	else if (powerstatus.isBatteryCharging)
	{
		document.getElementById('batt').style.visibility = "visible";
		document.getElementById('batt').style.color = "white";
		if  (lastpct == 100)
		{
			document.getElementById('battimage').src = "/img/BatteryPlugged.png";
		}
		else if  (lastpct >= 75)
		{
			document.getElementById('battimage').src = "/img/BatteryPlugged75.png";
		}
		else if (lastpct >= 50)
		{
			document.getElementById('battimage').src = "/img/BatteryPlugged50.png";
		}
		else
		{
			document.getElementById('battimage').src = "/img/BatteryPlugged25.png";
		}
		lastpcttext2= BattText[11]; //Charging
		lastpcttext = BattText[1];
	}
	else
	{
		document.getElementById('battimage').src = "/img/BatteryPlugged.png";
		lastpcttext = BattText[1];
		lastpcttext2= BattText[0]; //Fully charged
	}

	batt.innerText = lastpct + "%";

	if (powerstatus.isBatteryCharging)
	{
		batttxt.innerText = lastpcttext;
		battinfo.innerText = lastpcttext2;
	}
	else if (!powerstatus.isPowerLineConnected)//running on battery
	{
		batttxt.innerText = lastpcttext;
		battinfo.innerText = lastpcttext2;
	}
	else
	{
		batttxt.innerText = lastpcttext2;
		battinfo.innerText = lastpcttext;
	}
}

function padnumber(num)
{
	if(num < 10)
		return "0"+num;
	else
		return num;
}

function blinker() {
	refS = document.getElementById('batt').style;
	stat = stat? false : true;
	refS.visibility = stat? "hidden" : "visible";
}

//Checking network details
function networkInfo()
{
	var ssid = wireless.ssid;
	var strength = wireless.signalStrength;
	var ip = wireless.address;
	var primaryDNS = wireless.primaryDNSAddress;
	var security = wireless.secureConnection;

	//If connected, display the network information
	//if there's an SSID then you are connected
	if (ssid != "")
	{
		prcolor = true;
		status = true;
		if (ssid.length>13) ssid=ssid.substr(0,10)+"...";
		document.getElementById('netssid').style.color = "turquoise";
		if (security == true)
		{
			document.getElementById('encrypt').src = "/img/encrypted32.png"
			document.getElementById('netssid').innerText = ssid;
		}
		else
		{
			document.getElementById('encrypt').src = "/img/decrypted32.png"
			document.getElementById('netssid').innerText = ssid;
		}
		document.getElementById('networksignalpercent').innerText = strength + "%";
	}
	//If not connected, then display the filler
	else
	{
		prcolor = false;
		status = false;
		document.getElementById('encrypt').src = "/img/null.png"
		document.getElementById('netssid').innerText = BattText[7];
		document.getElementById('netssid').style.color = "red";
		document.getElementById('networksignalpercent').innerText = BattText[8];
	}
	if (prcolor == true)
	{
		if (strength <= 30)
		{
			document.getElementById('networksignalpercent').style.color = "red";
		}
		else if (strength <= 50)
		{
			document.getElementById('networksignalpercent').style.color = "yellow";
		}
		else
		{
			document.getElementById('networksignalpercent').style.color = "turquoise";
		}
	}
	else
	{
		document.getElementById('networksignalpercent').style.color = "red";
	}

	//Checking the signal strength and security and displaying the appropriate image
	//If connected to a network, then display the proper signal status image
	if (status == true)
	{
		if (strength >= 100)
		{
			document.getElementById('networksignal').src = "/img/Signal/20.png";
		}
		else if (strength > 95)
		{
			document.getElementById('networksignal').src = "/img/Signal/19.png";
		}
		else if (strength > 90)
		{
			document.getElementById('networksignal').src = "/img/Signal/18.png";
		}
		else if (strength > 85)
		{
			document.getElementById('networksignal').src = "/img/Signal/17.png";
		}
		else if (strength > 80)
		{
			document.getElementById('networksignal').src = "/img/Signal/16.png";
		}
		else if (strength > 75)
		{
			document.getElementById('networksignal').src = "/img/Signal/15.png";
		}
		else if (strength > 70)
		{
			document.getElementById('networksignal').src = "/img/Signal/14.png";
		}
		else if (strength > 65)
		{
			document.getElementById('networksignal').src = "/img/Signal/13.png";
		}
		else if (strength > 60)
		{
			document.getElementById('networksignal').src = "/img/Signal/12.png";
		}
		else if (strength > 55)
		{
			document.getElementById('networksignal').src = "/img/Signal/11.png";
		}
		else if (strength > 50)
		{
			document.getElementById('networksignal').src = "/img/Signal/10.png";
		}
		else if (strength > 45)
		{
			document.getElementById('networksignal').src = "/img/Signal/9.png";
		}
		else if (strength > 40)
		{
			document.getElementById('networksignal').src = "/img/Signal/8.png";
		}
		else if (strength > 35)
		{
			document.getElementById('networksignal').src = "/img/Signal/7.png";
		}
		else if (strength > 30)
		{
			document.getElementById('networksignal').src = "/img/Signal/6.png";
		}
		else if (strength > 25)
		{
			document.getElementById('networksignal').src = "/img/Signal/5.png";
		}
		else if (strength > 20)
		{
			document.getElementById('networksignal').src = "/img/Signal/4.png";
		}
		else if (strength > 15)
		{
			document.getElementById('networksignal').src = "/img/Signal/3.png";
		}
		else if (strength > 10)
		{
			document.getElementById('networksignal').src = "/img/Signal/2.png";
		}
		else if (strength > 0)
		{
			document.getElementById('networksignal').src = "/img/Signal/1.png";
		}
		else
		{
			document.getElementById('networksignal').src = "/img/Signal/0.png";
		}
	}
	//If disconencted, then show disconnected status image
	else
	{
		document.getElementById('networksignal').src = "/img/Signal/dc.png";
	}
}

function CPUInfo()
{
	if (DisplayDualCore)
	{
		var cpuscnt = cpus.count;
//		var cpuscnt = cpus.count / 2;
	}
	else
	{
		var cpuscnt = "1";
	}

	var cspeed0, cpseed1, oCPU, cperc0, cperc1;

//	document.getElementById('netssid').innerText = cpuscnt;

	if (cpuscnt > 1)
	{
		cspeed0 = getProcClock(0);
		cspeed1 = getProcClock(1);

		if(DisplayInGHz)
		{
			dtext0=round(cspeed0);
			dtext1=round(cspeed1);
			document.getElementById('dCSpeed').style.fontSize = "15";
			document.getElementById('dCSpeed').style.marginTop = "3";
			document.getElementById('dCSpeed').innerText = dtext0 + "|" + dtext1 + " GHz";
		}
		else
		{
			document.getElementById('dCSpeed').style.fontSize = "15";
			document.getElementById('dCSpeed').style.marginTop = "3";
			document.getElementById('dCSpeed').innerText = cspeed0 + "|" + cspeed1 + " MHz";
		}
	}
	else
	{
		cspeed0 = getProcClock(0);

		if(DisplayInGHz)
		{
			dtext0=round(cspeed0);
			document.getElementById('dCSpeed').style.fontSize = "20";
			document.getElementById('dCSpeed').style.marginTop = "0";
			document.getElementById('dCSpeed').innerText = dtext0 + " GHz";
		}
		else
		{
			document.getElementById('dCSpeed').style.fontSize = "20";
			document.getElementById('dCSpeed').style.marginTop = "0";
			document.getElementById('dCSpeed').innerText = cspeed0 + " MHz";
		}
	}
}

function getProcClock(cid)
{
	var proc;
	var query="SELECT CurrentClockSpeed FROM Win32_Processor WHERE DeviceID=";
//	var query="SELECT * FROM Win32_Processor WHERE DeviceID=";
//	var query="SELECT * FROM CIM_Processor WHERE DeviceID=";
	if (cid = "0")
	{
		query += "\"CPU0\"";
	}
	else if (cid = "1")
	{
		query += "\"CPU1\"";
	}

	proc = WMI.ExecQuery(query,"WQL",48);
	var enu = new Enumerator(proc);
	return enu.item().CurrentClockSpeed;

	return -1;
}

function getRemainingTime()
{
	var colItems = WMI.ExecQuery("SELECT EstimatedRunTime FROM Win32_Battery","WQL",48);
	var e = new Enumerator(colItems);
	return e.item().EstimatedRunTime;

	return -1;
}

function round(x) {
//		var k = Math.round(x / 10).toString();
	var k = (x / 1000).toString();
	k += (k.indexOf('.') == -1)? '.00' : '00';
	var p = k.indexOf('.'), m = k.indexOf('-.');
	var f = (p == 0 || m == 0)? '0,' : ',';
	return k.substring(0, p) + f + k.substring(p+1, p+3);
}

function updateWMTT(e)
{
	x = (!e) ? window.event.x + document.body.scrollLeft : e.pageX;
	y = (!e) ? window.event.y + document.body.scrollTop: e.pageY;
}

function showWMTT(id)
{
	wmtt = document.getElementById(id);
	wmtt.style.display = "block";
	if(typeof document.body.scrollLeft=='number')
	{
		w = document.body.scrollLeft + document.body.clientWidth;
		h = document.body.scrollTop + document.body.clientHeight
	}
	else if(typeof window.pageYOffset=='number')
	{
		w = window.pageXOffset+window.innerWidth;
		h = window.pageYOffset+window.innerHeight
	}
	t = y + 20;
	l = x + 20;
	if(t + wmtt.offsetHeight > h) wmtt.style.top = y - 1 - wmtt.offsetHeight + 'px';
	else wmtt.style.top = t + "px";
	if(l + wmtt.offsetWidth > w) wmtt.style.left = w - 1 - wmtt.offsetWidth+'px';
	else wmtt.style.left = l + "px";
}

function hideWMTT()
{
	wmtt.style.display = "none";
}

function LaunchApplet(wert)
{
    if (wert == "power")
    {
//    	System.Shell.execute(System.Environment.getEnvironmentVariable("SystemRoot") + "\\System32\\powercfg.cpl");
		System.Shell.execute(System.Environment.getEnvironmentVariable("SystemRoot") + "\\System32\\mblctr.exe", "/open");
    }
    else if (wert == "cpu")
    {
    	System.Shell.execute(System.Environment.getEnvironmentVariable("SystemRoot") + "\\System32\\taskmgr.exe");
    }
    else if (wert == "net")
    {
		System.Shell.execute("::{20d04fe0-3aea-1069-a2d8-08002b30309d}\\::{21ec2020-3aea-1069-a2dd-08002b30309d}\\::{38A98528-6CBF-4CA9-8DC0-B1E1D10F7B1B}");
//    	System.Shell.execute(System.Environment.getEnvironmentVariable("SystemRoot") + "\\System32\\ncpa.cpl");
    }
}

//Opening the flyout details box
function showFlyout(wert)
{
	System.Gadget.Flyout.file = wert + "flyout.html";
	System.Gadget.Flyout.show = true;
}

function SettingsClosed(event)
{
	LoadSettings()
}


